Main Page Class List Class Members

# Nv::Blast::ExtPxFamily Class Reference

`#include <NvBlastExtPxFamily.h>`

Inheritance diagram for Nv::Blast::ExtPxFamily:

List of all members.

## Public Member Functions
virtual bool | despawn ()=0
virtual uint32_t | getActorCount () const =0
virtual uint32_t | getActors (ExtPxActor **buffer, uint32_t bufferSize) const =0
virtual const NvBlastExtMaterial * | getMaterial () const =0
virtual const ExtPxActorDescTemplate * | getPxActorDesc () const =0
virtual ExtPxAsset & | getPxAsset () const =0
virtual const ExtPxShapeDescTemplate * | getPxShapeDescTemplate () const =0
virtual const physx::PxShape *const * | getSubchunkShapes () const =0
virtual TkFamily & | getTkFamily () const =0
virtual void | postSplitUpdate ()=0
virtual void | release ()=0
virtual void | setMaterial (const NvBlastExtMaterial *material)=0
virtual void | setMaterial (physx::PxMaterial &material)=0
virtual void | setPxActorDesc (const ExtPxActorDescTemplate *pxActorDesc)=0
virtual void | setPxShapeDescTemplate (const ExtPxShapeDescTemplate *pxShapeDesc)=0
virtual bool | spawn (const physx::PxTransform &pose, const physx::PxVec3 &scale, const ExtPxSpawnSettings &settings)=0
virtual void | subscribe (ExtPxListener &listener)=0
virtual void | unsubscribe (ExtPxListener &listener)=0
## Public Attributes
void * | userData

## Detailed Description

PxFamily.

A collection of actors. Maps 1 to 1 with TkFamily.

## Member Function Documentation

virtual bool Nv::Blast::ExtPxFamily::despawn | ( |  | ) | `[pure virtual]`

Despawn this ExtPxFamily. This removes the PhysX actors from PxScene and deletes them, as well as deleting the created ExtPxActors

This does not call release() on the family.

Returns:
  true if successful.

Implemented in Nv::Blast::final.

virtual uint32_t Nv::Blast::ExtPxFamily::getActorCount | ( |  | ) | const`[pure virtual]`

The number of actors currently in this family.

Returns:
  the number of ExtPxActor that currently exist in this family.

Implemented in Nv::Blast::final.

virtual uint32_t Nv::Blast::ExtPxFamily::getActors | ( | ExtPxActor ** | buffer,
|  | uint32_t | bufferSize |
| ) |  |  | const`[pure virtual]`

Retrieve an array of pointers (into the user-supplied buffer) to actors.

Parameters:

  `[out]` | buffer | A user-supplied array of ExtPxActor pointers.
  `[in]` | bufferSize | The number of elements available to write into buffer.

Returns:
  the number of ExtPxActor pointers written to the buffer.

Implemented in Nv::Blast::final.

virtual const NvBlastExtMaterial* Nv::Blast::ExtPxFamily::getMaterial | ( |  | ) | const`[pure virtual]`

The default material associated with this actor family.

Returns:
  a pointer to the default material.

Implemented in Nv::Blast::final.

virtual const ExtPxActorDescTemplate* Nv::Blast::ExtPxFamily::getPxActorDesc | ( |  | ) | const`[pure virtual]`

Get the default ExtPxPxActorDesc to be used on all newly created PxActors.

Returns:
  a pointer to the default PxActor desc. Can be nullptr.

Implemented in Nv::Blast::final.

virtual ExtPxAsset& Nv::Blast::ExtPxFamily::getPxAsset | ( |  | ) | const`[pure virtual]`

Every family has an associated asset.

Returns:
  a pointer to the (const) ExtPxAsset object.

Implemented in Nv::Blast::final.

virtual const ExtPxShapeDescTemplate* Nv::Blast::ExtPxFamily::getPxShapeDescTemplate | ( |  | ) | const`[pure virtual]`

Get the default ExtPxPxShapeDesc to be used on all newly created PxShapes.

Returns:
  a pointer to the default PxShape desc. Can be nullptr.

Implemented in Nv::Blast::final.

virtual const physx::PxShape* const* Nv::Blast::ExtPxFamily::getSubchunkShapes | ( |  | ) | const`[pure virtual]`

Access an array of shapes of subchunks. The size of array is equal getPxAsset()->getSubchunkCount(). For every corresponding subchunk it contains pointer to created PxShape or nullptr.

Returns:
  the pointer to subchunk shapes array.

Implemented in Nv::Blast::final.

virtual TkFamily& Nv::Blast::ExtPxFamily::getTkFamily | ( |  | ) | const`[pure virtual]`

Every family has corresponding TkFamily.

/return a pointer to TkFamily actor.

Implemented in Nv::Blast::final.

virtual void Nv::Blast::ExtPxFamily::postSplitUpdate | ( |  | ) | `[pure virtual]`

Call after split.

Implemented in Nv::Blast::final.

virtual void Nv::Blast::ExtPxFamily::release | ( |  | ) | `[pure virtual]`

Release this family.

Implemented in Nv::Blast::final, Nv::Blast::final, Nv::Blast::final, Nv::Blast::final, Nv::Blast::final, and Nv::Blast::final.

virtual void Nv::Blast::ExtPxFamily::setMaterial | ( | const NvBlastExtMaterial * | material | ) | `[pure virtual]`

Set the default material associated with this actor family.

Parameters:

  `[in]` | material | The material to be the new default.

Implemented in Nv::Blast::final.

virtual void Nv::Blast::ExtPxFamily::setMaterial | ( | physx::PxMaterial & | material | ) | `[pure virtual]`

Set the default material to be used for PxRigidDynamic creation.

Parameters:

  `[in]` | material | The material to be the new default.

virtual void Nv::Blast::ExtPxFamily::setPxActorDesc | ( | const ExtPxActorDescTemplate * | pxActorDesc | ) | `[pure virtual]`

Implemented in Nv::Blast::final.

virtual void Nv::Blast::ExtPxFamily::setPxShapeDescTemplate | ( | const ExtPxShapeDescTemplate * | pxShapeDesc | ) | `[pure virtual]`

Implemented in Nv::Blast::final.

virtual bool Nv::Blast::ExtPxFamily::spawn | ( | const physx::PxTransform & | pose,
|  | const physx::PxVec3 & | scale,
|  | const ExtPxSpawnSettings & | settings |
| ) |  |  | `[pure virtual]`

Spawn ExtPxFamily. Can be called only once. Actual PhysX actors will created and placed in PxScene

Parameters:

  `[in]` | pose | World transform.
  `[in]` | scale | Scale applied to spawned actors.
  `[in]` | settings | Spawn settings.

Returns:
  true if spawn was successful, false otherwise.

Implemented in Nv::Blast::final.

virtual void Nv::Blast::ExtPxFamily::subscribe | ( | ExtPxListener & | listener | ) | `[pure virtual]`

Add a user implementation of ExtPxListener to this family's list of listeners.

Parameters:

  `[in]` | listener | The event listener to add.

Implemented in Nv::Blast::final, and Nv::Blast::final.

virtual void Nv::Blast::ExtPxFamily::unsubscribe | ( | ExtPxListener & | listener | ) | `[pure virtual]`

Remove a user implementation of ExtPxListener from this family's list of listeners.

Parameters:

  `[in]` | listener | The event listener to remove.

Implemented in Nv::Blast::final, and Nv::Blast::final.

## Member Data Documentation

void* Nv::Blast::ExtPxFamily::userData

UserData pointer. Free to be used by user in any way.

The documentation for this class was generated from the following file:

- sdk/extensions/physx/include/NvBlastExtPxFamily.h